"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require("lodash");
function makeList(values, power, start) {
    if (start === void 0) { start = 0; }
    return _.map(_.range(start, values.length + start), function (i) {
        return {
            label: values[i - start],
            value: Math.pow(power, i)
        };
    });
}
var kb = 1024;
var seconds = 60;
var BYTE_SIZES = makeList(['B', 'KiB', 'MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'], kb);
exports.BYTE_SIZES = BYTE_SIZES;
var MEGABYTE_SIZES = makeList(['MiB', 'GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'], kb);
exports.MEGABYTE_SIZES = MEGABYTE_SIZES;
var GIGABYTE_SIZES = makeList(['GiB', 'TiB', 'PiB', 'EiB', 'ZiB', 'YiB'], kb);
exports.GIGABYTE_SIZES = GIGABYTE_SIZES;
var TRANSFER_SPEED = makeList(['B/s', 'KiB/s', 'MiB/s', 'GiB/s', 'TiB/s', 'PiB/s', 'EiB/s', 'ZiB/s', 'YiB/s'], kb);
exports.TRANSFER_SPEED = TRANSFER_SPEED;
var SECONDS = makeList(['secs', 'mins', 'hrs'], seconds);
exports.SECONDS = SECONDS;
var HOURS = [{ label: 'hours', value: 3600 },
    { label: 'days', value: 86400 },
    { label: 'weeks', value: 604800 }];
exports.HOURS = HOURS;
