"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_dao_1 = require("./abstract-dao");
var model_1 = require("../model");
var _ = require("lodash");
var DockerNetworkDao = (function (_super) {
    __extends(DockerNetworkDao, _super);
    function DockerNetworkDao() {
        return _super.call(this, model_1.Model.DockerNetwork, {
            eventName: 'entity-subscriber.docker.network.changed'
        }) || this;
    }
    DockerNetworkDao.prototype.getNewInstance = function () {
        // FIXME: needed because there is a bug in frb or collection
        // that doesn't changes in the select-multiple when this property is undefined.
        return _super.prototype.getNewInstance.call(this).then(function (dockerNetwork) { return _.assign(dockerNetwork, { containers: [] }); });
    };
    DockerNetworkDao.prototype.connect = function (networkId, containersIds) {
        return this.middlewareClient.submitTask('docker.network.connect', [containersIds, networkId]);
    };
    DockerNetworkDao.prototype.disconnect = function (networkId, containersIds) {
        return this.middlewareClient.submitTask('docker.network.disconnect', [containersIds, networkId]);
    };
    return DockerNetworkDao;
}(abstract_dao_1.AbstractDao));
exports.DockerNetworkDao = DockerNetworkDao;
