"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var model_1 = require("./model");
var ModelEventName = (function () {
    function ModelEventName(modelName) {
        this.listChange = modelName + 'ListChange';
        this.contentChange = modelName + 'ContentChange';
        this.add = function (id) { return modelName + 'Add.' + id; };
        this.remove = function (id) { return modelName + 'Remove.' + id; };
        this.change = function (id) { return modelName + '.' + id; };
    }
    return ModelEventName;
}());
ModelEventName.AccountCategory = new ModelEventName(model_1.Model.AccountCategory);
ModelEventName.AccountSystem = new ModelEventName(model_1.Model.AccountSystem);
ModelEventName.Alert = new ModelEventName(model_1.Model.Alert);
ModelEventName.AlertEmitter = new ModelEventName(model_1.Model.AlertEmitter);
ModelEventName.AlertFilter = new ModelEventName(model_1.Model.AlertFilter);
ModelEventName.AlertSettings = new ModelEventName(model_1.Model.AlertSettings);
ModelEventName.AmazonS3Credentials = new ModelEventName(model_1.Model.AmazonS3Credentials);
ModelEventName.BootEnvironment = new ModelEventName(model_1.Model.BootEnvironment);
ModelEventName.BootPool = new ModelEventName(model_1.Model.BootPool);
ModelEventName.Calendar = new ModelEventName(model_1.Model.Calendar);
ModelEventName.CalendarTask = new ModelEventName(model_1.Model.CalendarTask);
ModelEventName.CryptoCertificate = new ModelEventName(model_1.Model.CryptoCertificate);
ModelEventName.Database = new ModelEventName(model_1.Model.Database);
ModelEventName.Debug = new ModelEventName(model_1.Model.Debug);
ModelEventName.DetachedVolume = new ModelEventName(model_1.Model.DetachedVolume);
ModelEventName.Directory = new ModelEventName(model_1.Model.Directory);
ModelEventName.DirectoryserviceConfig = new ModelEventName(model_1.Model.DirectoryserviceConfig);
ModelEventName.DirectoryServices = new ModelEventName(model_1.Model.DirectoryServices);
ModelEventName.Disk = new ModelEventName(model_1.Model.Disk);
ModelEventName.DiskUsage = new ModelEventName(model_1.Model.DiskUsage);
ModelEventName.DockerCollection = new ModelEventName(model_1.Model.DockerCollection);
ModelEventName.DockerConfig = new ModelEventName(model_1.Model.DockerConfig);
ModelEventName.DockerContainer = new ModelEventName(model_1.Model.DockerContainer);
ModelEventName.DockerContainerBridge = new ModelEventName(model_1.Model.DockerContainerBridge);
ModelEventName.DockerContainerCreator = new ModelEventName(model_1.Model.DockerContainerCreator);
ModelEventName.DockerContainerLogs = new ModelEventName(model_1.Model.DockerContainerLogs);
ModelEventName.DockerContainerSection = new ModelEventName(model_1.Model.DockerContainerSection);
ModelEventName.DockerHost = new ModelEventName(model_1.Model.DockerHost);
ModelEventName.DockerImage = new ModelEventName(model_1.Model.DockerImage);
ModelEventName.DockerImageReadme = new ModelEventName(model_1.Model.DockerImageReadme);
ModelEventName.DockerImagePull = new ModelEventName(model_1.Model.DockerImagePull);
ModelEventName.DockerNetwork = new ModelEventName(model_1.Model.DockerNetwork);
ModelEventName.EncryptedVolumeActions = new ModelEventName(model_1.Model.EncryptedVolumeActions);
ModelEventName.EncryptedVolumeImporter = new ModelEventName(model_1.Model.EncryptedVolumeImporter);
ModelEventName.FreenasCredentials = new ModelEventName(model_1.Model.FreenasCredentials);
ModelEventName.Group = new ModelEventName(model_1.Model.Group);
ModelEventName.ImportableDisk = new ModelEventName(model_1.Model.ImportableDisk);
ModelEventName.Ipmi = new ModelEventName(model_1.Model.Ipmi);
ModelEventName.KerberosKeytab = new ModelEventName(model_1.Model.KerberosKeytab);
ModelEventName.KerberosRealm = new ModelEventName(model_1.Model.KerberosRealm);
ModelEventName.Mail = new ModelEventName(model_1.Model.AlertEmitterEmail);
ModelEventName.NetworkConfig = new ModelEventName(model_1.Model.NetworkConfig);
ModelEventName.NetworkHost = new ModelEventName(model_1.Model.NetworkHost);
ModelEventName.NetworkInterface = new ModelEventName(model_1.Model.NetworkInterface);
ModelEventName.NetworkInterfaceBridgeProperties = new ModelEventName(model_1.Model.NetworkInterfaceBridgeProperties);
ModelEventName.NetworkInterfaceLaggProperties = new ModelEventName(model_1.Model.NetworkInterfaceLaggProperties);
ModelEventName.NetworkInterfaceVlanProperties = new ModelEventName(model_1.Model.NetworkInterfaceVlanProperties);
ModelEventName.NetworkRoute = new ModelEventName(model_1.Model.NetworkRoute);
ModelEventName.NtpServer = new ModelEventName(model_1.Model.NtpServer);
ModelEventName.Peer = new ModelEventName(model_1.Model.Peer);
ModelEventName.Permissions = new ModelEventName(model_1.Model.Permissions);
ModelEventName.Replication = new ModelEventName(model_1.Model.Replication);
ModelEventName.ReplicationOptions = new ModelEventName(model_1.Model.ReplicationOptions);
ModelEventName.RsyncdModule = new ModelEventName(model_1.Model.RsyncdModule);
ModelEventName.Section = new ModelEventName(model_1.Model.Section);
ModelEventName.SectionSettings = new ModelEventName(model_1.Model.SectionSettings);
ModelEventName.Service = new ModelEventName(model_1.Model.Service);
ModelEventName.ServiceDc = new ModelEventName(model_1.Model.ServiceDc);
ModelEventName.ServiceDyndns = new ModelEventName(model_1.Model.ServiceDyndns);
ModelEventName.ServicesCategory = new ModelEventName(model_1.Model.ServicesCategory);
ModelEventName.ServiceUps = new ModelEventName(model_1.Model.ServiceUps);
ModelEventName.Share = new ModelEventName(model_1.Model.Share);
ModelEventName.ShareIscsiTarget = new ModelEventName(model_1.Model.ShareIscsiTarget);
ModelEventName.SshCredentials = new ModelEventName(model_1.Model.SshCredentials);
ModelEventName.SupportCategory = new ModelEventName(model_1.Model.SupportCategory);
ModelEventName.SupportTicket = new ModelEventName(model_1.Model.SupportTicket);
ModelEventName.SystemAdvanced = new ModelEventName(model_1.Model.SystemAdvanced);
ModelEventName.SystemGeneral = new ModelEventName(model_1.Model.SystemGeneral);
ModelEventName.SystemSection = new ModelEventName(model_1.Model.SystemSection);
ModelEventName.SystemTime = new ModelEventName(model_1.Model.SystemTime);
ModelEventName.SystemUi = new ModelEventName(model_1.Model.SystemUi);
ModelEventName.Task = new ModelEventName(model_1.Model.Task);
ModelEventName.Tunable = new ModelEventName(model_1.Model.Tunable);
ModelEventName.Update = new ModelEventName(model_1.Model.Update);
ModelEventName.User = new ModelEventName(model_1.Model.User);
ModelEventName.Vm = new ModelEventName(model_1.Model.Vm);
ModelEventName.VmClone = new ModelEventName(model_1.Model.VmClone);
ModelEventName.VmConfig = new ModelEventName(model_1.Model.VmConfig);
ModelEventName.VmDatastore = new ModelEventName(model_1.Model.VmDatastore);
ModelEventName.VmDevice = new ModelEventName(model_1.Model.VmDevice);
ModelEventName.VmReadme = new ModelEventName(model_1.Model.VmReadme);
ModelEventName.VmSnapshot = new ModelEventName(model_1.Model.VmSnapshot);
ModelEventName.VmTemplate = new ModelEventName(model_1.Model.VmTemplate);
ModelEventName.VmVolume = new ModelEventName(model_1.Model.VmVolume);
ModelEventName.VmwareCredentials = new ModelEventName(model_1.Model.VmwareCredentials);
ModelEventName.VmwareDataset = new ModelEventName(model_1.Model.VmwareDataset);
ModelEventName.VmwareDatastore = new ModelEventName(model_1.Model.VmwareDatastore);
ModelEventName.Volume = new ModelEventName(model_1.Model.Volume);
ModelEventName.VolumeDataset = new ModelEventName(model_1.Model.VolumeDataset);
ModelEventName.VolumeDatasetProperties = new ModelEventName(model_1.Model.VolumeDatasetProperties);
ModelEventName.VolumeDatasetPropertyAtime = new ModelEventName(model_1.Model.VolumeDatasetPropertyAtime);
ModelEventName.VolumeDatasetPropertyCasesensitivity = new ModelEventName(model_1.Model.VolumeDatasetPropertyCasesensitivity);
ModelEventName.VolumeDatasetPropertyCompression = new ModelEventName(model_1.Model.VolumeDatasetPropertyCompression);
ModelEventName.VolumeDatasetPropertyDedup = new ModelEventName(model_1.Model.VolumeDatasetPropertyDedup);
ModelEventName.VolumeDatasetPropertyQuota = new ModelEventName(model_1.Model.VolumeDatasetPropertyQuota);
ModelEventName.VolumeDatasetPropertyRefquota = new ModelEventName(model_1.Model.VolumeDatasetPropertyRefquota);
ModelEventName.VolumeDatasetPropertyRefreservation = new ModelEventName(model_1.Model.VolumeDatasetPropertyRefreservation);
ModelEventName.VolumeDatasetPropertyReservation = new ModelEventName(model_1.Model.VolumeDatasetPropertyReservation);
ModelEventName.VolumeDatasetPropertyVolblocksize = new ModelEventName(model_1.Model.VolumeDatasetPropertyVolblocksize);
ModelEventName.VolumeImporter = new ModelEventName(model_1.Model.VolumeImporter);
ModelEventName.VolumeSnapshot = new ModelEventName(model_1.Model.VolumeSnapshot);
ModelEventName.VolumeVdevRecommendations = new ModelEventName(model_1.Model.VolumeVdevRecommendations);
ModelEventName.ZfsTopology = new ModelEventName(model_1.Model.ZfsTopology);
ModelEventName.ZfsVdev = new ModelEventName(model_1.Model.ZfsVdev);
exports.ModelEventName = ModelEventName;
