"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var vm_snapshot_dao_1 = require("../dao/vm-snapshot-dao");
var VmSnapshotRepository = (function (_super) {
    __extends(VmSnapshotRepository, _super);
    function VmSnapshotRepository(vmSnapshotDao) {
        var _this = _super.call(this, vmSnapshotDao) || this;
        _this.vmSnapshotDao = vmSnapshotDao;
        return _this;
    }
    VmSnapshotRepository.getInstance = function () {
        if (!VmSnapshotRepository.instance) {
            VmSnapshotRepository.instance = new VmSnapshotRepository(new vm_snapshot_dao_1.VmSnapshotDao());
        }
        return VmSnapshotRepository.instance;
    };
    VmSnapshotRepository.prototype.snapshotVmToName = function (vmId, name, description) {
        return this.vmSnapshotDao.createSnapshot(vmId, name, description);
    };
    VmSnapshotRepository.prototype.getNewVmSnapshot = function () {
        return this.vmSnapshotDao.getNewInstance();
    };
    VmSnapshotRepository.prototype.rollbackToSnapshot = function (snapshotId) {
        return this.vmSnapshotDao.rollbackToSnapshot(snapshotId);
    };
    return VmSnapshotRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.VmSnapshotRepository = VmSnapshotRepository;
