"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_repository_1 = require("./abstract-repository");
var model_event_name_1 = require("../model-event-name");
var _ = require("lodash");
var AbstractModelRepository = (function (_super) {
    __extends(AbstractModelRepository, _super);
    function AbstractModelRepository(dao) {
        var _this = _super.call(this, [dao.objectType]) || this;
        _this.dao = dao;
        _this.modelEventName = model_event_name_1.ModelEventName[dao.objectType];
        return _this;
    }
    AbstractModelRepository.prototype.list = function () {
        return this.localState ? Promise.resolve(_.assign(this.localState.valueSeq().toJS(), { _objectType: this.dao.objectType })) : this.dao.list();
    };
    AbstractModelRepository.prototype.save = function (object, args) {
        return this.dao.save(object, args);
    };
    AbstractModelRepository.prototype.delete = function (object, args) {
        return this.dao.delete(object, args);
    };
    AbstractModelRepository.prototype.getNewInstance = function () {
        return this.dao.getNewInstance();
    };
    AbstractModelRepository.prototype.getEmptyList = function () {
        return this.dao.getEmptyList();
    };
    AbstractModelRepository.prototype.handleStateChange = function (name, state) {
        this.localState = this.dispatchModelEvents(this.localState, this.modelEventName, state);
    };
    AbstractModelRepository.prototype.handleEvent = function (name, data) {
    };
    return AbstractModelRepository;
}(abstract_repository_1.AbstractRepository));
exports.AbstractModelRepository = AbstractModelRepository;
