"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var docker_container_dao_1 = require("../dao/docker-container-dao");
var docker_container_bridge_repository_1 = require("./docker-container-bridge-repository");
var DockerContainerRepository = (function (_super) {
    __extends(DockerContainerRepository, _super);
    function DockerContainerRepository(dockerContainerDao) {
        var _this = _super.call(this, dockerContainerDao) || this;
        _this.dockerContainerDao = dockerContainerDao;
        _this.dockerContainerBridgeRepository = docker_container_bridge_repository_1.DockerContainerBridgeRepository.getInstance();
        return _this;
    }
    DockerContainerRepository.getInstance = function () {
        if (!DockerContainerRepository.instance) {
            DockerContainerRepository.instance = new DockerContainerRepository(new docker_container_dao_1.DockerContainerDao());
        }
        return DockerContainerRepository.instance;
    };
    DockerContainerRepository.prototype.listDockerContainers = function () {
        return this.dockerContainerDao.list();
    };
    DockerContainerRepository.prototype.getNewDockerContainer = function () {
        var _this = this;
        return this.dockerContainerDao.getNewInstance().then(function (container) {
            container.primary_network_mode = 'NAT';
            return _this.dockerContainerBridgeRepository.getNewDockerContainerBridge().then(function (bridge) {
                container.bridge = bridge;
                return container;
            });
        });
    };
    DockerContainerRepository.prototype.saveContainer = function (container) {
        return this.dockerContainerDao.save(container);
    };
    DockerContainerRepository.prototype.getInteractiveConsoleToken = function (containerId) {
        return this.dockerContainerDao.requestInteractiveConsole(containerId);
    };
    DockerContainerRepository.prototype.getSerialConsoleToken = function (containerId) {
        return this.dockerContainerDao.requestSerialConsole(containerId);
    };
    DockerContainerRepository.prototype.startContainer = function (container) {
        return this.dockerContainerDao.start(container);
    };
    DockerContainerRepository.prototype.restartContainer = function (container) {
        return this.dockerContainerDao.restart(container);
    };
    DockerContainerRepository.prototype.stopContainer = function (container) {
        return this.dockerContainerDao.stop(container);
    };
    DockerContainerRepository.prototype.generateMacAddress = function () {
        return this.dockerContainerDao.generateMacAddress();
    };
    return DockerContainerRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.DockerContainerRepository = DockerContainerRepository;
