"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var docker_image_dao_1 = require("../dao/docker-image-dao");
var DockerImageRepository = (function (_super) {
    __extends(DockerImageRepository, _super);
    function DockerImageRepository(dockerImageDao) {
        var _this = _super.call(this, dockerImageDao) || this;
        _this.dockerImageDao = dockerImageDao;
        return _this;
    }
    DockerImageRepository.getInstance = function () {
        if (!DockerImageRepository.instance) {
            DockerImageRepository.instance = new DockerImageRepository(new docker_image_dao_1.DockerImageDao());
        }
        return DockerImageRepository.instance;
    };
    DockerImageRepository.prototype.getNewDockerImage = function () {
        return this.dockerImageDao.getNewInstance();
    };
    DockerImageRepository.prototype.listDockerImages = function () {
        return this.list();
    };
    DockerImageRepository.prototype.getReadmeForDockerImage = function (imageName) {
        return this.dockerImageDao.readme(imageName);
    };
    DockerImageRepository.prototype.pullImageToHost = function (imageName, hostId) {
        return this.dockerImageDao.pullToHost(imageName, hostId);
    };
    DockerImageRepository.prototype.deleteImageFromHost = function (imageName, hostId) {
        return this.dockerImageDao.deleteFromHost(imageName, hostId);
    };
    return DockerImageRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.DockerImageRepository = DockerImageRepository;
