"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_repository_1 = require("./abstract-repository");
var shell_dao_1 = require("../dao/shell-dao");
var ShellRepository = (function (_super) {
    __extends(ShellRepository, _super);
    function ShellRepository(shellDao) {
        var _this = _super.call(this) || this;
        _this.shellDao = shellDao;
        return _this;
    }
    ShellRepository.getInstance = function () {
        if (!ShellRepository.instance) {
            ShellRepository.instance = new ShellRepository(new shell_dao_1.ShellDao());
        }
        return ShellRepository.instance;
    };
    ShellRepository.prototype.listShells = function () {
        var self = this;
        return this.shells ? Promise.resolve(this.shells) : this.shellDao.list().then(function (shells) { return self.shells = shells; });
    };
    ShellRepository.prototype.spawn = function (columns, lines) {
        columns = columns || 80;
        lines = lines || 24;
        return this.shellDao.spawn(columns, lines);
    };
    ShellRepository.prototype.handleStateChange = function (name, state) { };
    ShellRepository.prototype.handleEvent = function (name, data) { };
    return ShellRepository;
}(abstract_repository_1.AbstractRepository));
exports.ShellRepository = ShellRepository;
