"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var task_dao_1 = require("../dao/task-dao");
var _ = require("lodash");
var abstract_model_repository_1 = require("./abstract-model-repository");
var TaskRepository = (function (_super) {
    __extends(TaskRepository, _super);
    function TaskRepository(taskDao) {
        var _this = _super.call(this, taskDao) || this;
        _this.taskDao = taskDao;
        return _this;
    }
    TaskRepository.getInstance = function () {
        if (!TaskRepository.instance) {
            TaskRepository.instance = new TaskRepository(new task_dao_1.TaskDao());
        }
        return TaskRepository.instance;
    };
    TaskRepository.prototype.listTasks = function () {
        return this.list();
    };
    TaskRepository.prototype.findTasks = function (criteria) {
        return this.taskDao.find(criteria);
    };
    TaskRepository.prototype.getTask = function (taskId) {
        return this.listTasks().then(function (tasks) { return _.find(tasks, { id: taskId }); });
    };
    TaskRepository.prototype.registerToTasks = function () {
        return this.taskDao.register();
    };
    TaskRepository.prototype.submitTask = function (name, args) {
        return this.taskDao.submit(name, args);
    };
    TaskRepository.prototype.abortTask = function (taskId) {
        return this.taskDao.abort(taskId);
    };
    return TaskRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.TaskRepository = TaskRepository;
