## Overview

Montage Data is a framework that allows
[Montage](https://github.com/montagejs/montage) applications to easily exchange
data with servers. It maps server data to model objects accessible in
application code, allowing complex server operations to be performed by reading
and writing the properties of model objects obtained with simple queries and
by traversing relationships.

Montage Data is an Object Service Mapping (OSM) framework: Just like an Object
Relational Mapping (ORM) framework maps relational data to application objects
and vice versa, Montage Data maps REST and other services to application objects
and vice versa.

## Documentation

Documentation can be generated by installing JSDoc 3.3.3 or newer and executing
`jsdoc -c .jsdoc.conf.json` in the root of the project, and it can be read by
opening the resulting `out/doc/index.html` in a web browser.

Developers editing Montage Data on OS X can make the documentation update
automatically whenever the source changes by copying the source's `.watch.plist`
file to `~/Library/LaunchAgents/com.kaazing.montagedata.watch.plist`, then
editing that file to replace all occurences of "/absolute/path/to/montage-data/"
with the absolute path of the source directory, and then running the following
in a terminal:

```sh
launchctl load ~/Library/LaunchAgents/com.kaazing.montagedata.watch.plist
launchctl start ~/Library/LaunchAgents/com.kaazing.montagedata.watch.plist
```

## Testing

All non-disabled tests should always pass.

Tests can be run by executing `npm install` in the `test` subdirectory and then
loading `test/index.html` through a web server. Tests can be created by editing
`test/index.reel/index.js`.
